	IFND	PV_DEBUGBASE_I
PV_DEBUGBASE_I	SET	1
**
**  $Filename: DebugBase.i $
**  $Release: 1.13 $
**  $Revision: 37.809 $
**  $Date: 6 Feb 92 $
**
**  Structure definitions for Debug Base (see 'TheWizardCorner')
**
**   1991 Jorrit Tyberghein, included with PowerVisor
**	    All Rights Reserved
**

	IFND PV_PVMEMORY_I
	INCLUDE "PV/PVMemory.i"
	ENDC

	IFND EXEC_LISTS_I
	INCLUDE "exec/lists.i"
	ENDC


TRACE_NONE	equ	0
TRACE_TRACE	equ	1
TRACE_EXEC	equ	2

TRACES_NORMAL	equ	0
TRACES_TTRACE	equ	1
TRACES_CRASH	equ	2
TRACES_BREAK	equ	3
TRACES_TBREAK	equ	4
TRACES_WAIT	equ	5
TRACES_ERROR	equ	6

TRACET_NORMAL	equ	0
TRACET_AFTER	equ	1
TRACET_STEP	equ	2
TRACET_UNTIL	equ	3
TRACET_REG	equ	4
TRACET_COND	equ	5
TRACET_BRANCH	equ	6
TRACET_FORCE	equ	7
TRACET_OSCALL	equ	8
TRACET_SKIP	equ	9


	STRUCTURE	BreakpointNode,LN_SIZE
		UWORD	bpn_Number
		APTR	bpn_Address
		UWORD	bpn_OrigContents
		UBYTE	bpn_Type
		UBYTE	bpn_pad0
		ULONG	bpn_UsageCount
		ULONG	bpn_AdditionalArg
		APTR	bpn_BreakRout
		ULONG	bpn_pad1
		LABEL	bpn_SIZE

	STRUCTURE	DebugNode,LN_SIZE
		ULONG	dbn_MatchWord	;'DBUG'
		UBYTE	dbn_Mode
		UBYTE	dbn_SMode
		BPTR	dbn_LoadedSegment
		APTR	dbn_ProgramCounter
		APTR	dbn_TempRout
		APTR	dbn_TraceExceptRout
		APTR	dbn_RestoreBreakpoint
		ULONG	dbn_AdditionalInfo
		UBYTE	dbn_TMode
		UBYTE	dbn_pad0
		UBYTE	dbn_TDNestCnt
		UBYTE	dbn_IDNestCnt
		UBYTE	dbn_TaskState
		UBYTE	dbn_Dirty
		ULONG	dbn_SigWait
		ULONG	dbn_CrashNum
		ULONG	dbn_AdditionalArg
		APTR	dbn_DebugTask
		ULONG	dbn_TopPC
		ULONG	dbn_BottomPC
		UWORD	dbn_LastDumpLine
		STRUCT	dbn_InstructionBytes,32
		APTR	dbn_InitPC
		APTR	dbn_OldTrapCode
		STRUCT	dbn_Symbols,pvqb_SIZE
		STRUCT	dbn_Strings,pvqb_SIZE
		STRUCT	dbn_Breakpoints,LH_SIZE
		UWORD	dbn_pad1
		ULONG	dbn_pad2
		UWORD	dbn_pad3
		UBYTE	dbn_pad4
		UBYTE	dbn_pad5
		APTR	dbn_QuitCode
		APTR	dbn_OrigQuitCode
		ULONG	dbn_SP
		ULONG	dbn_PC
		UWORD	dbn_SR
		STRUCT	dbn_Registers,15
		UBYTE	dbn_pad6,16
		APTR	dbn_Source
		APTR	dbn_CurrentSource
		LABEL	dbn_SIZE

	STRUCTURE SourceFile,0
		APTR	srcf_Next	;Next source
		APTR	srcf_Prev	;Previous source
		APTR	srcf_FileName	;Filename
		ULONG	srcf_LinesSize	;Size of lines block
		APTR	srcf_Lines	;Pointer to lines block
		ULONG	srcf_FileSize	;Size of the file block
		APTR	srcf_File	;Pointer to loaded file
		ULONG	srcf_LineNumber	;Current linenumber in file
		ULONG	srcf_TopLine	;Top linenumber
		ULONG	srcf_BottomLine	;Bottom linenumber
		ULONG	srcf_HiLine	;Current hilighted line
		LABEL	srcf_SIZE

	STRUCTURE	DebugBase,0
		ULONG	dbase_FloatingPoint
		STRUCT	dbase_DebugTasks,LH_SIZE
		APTR	dbase_CurrentDebug
		STRUCT	dbase_pad0,16
		STRUCT	dbase_pad1,8
		UBYTE	dbase_ShowRegInfo
		UBYTE	dbase_GiveDisassembly
		UWORD	dbase_NumLinesToDisassemble
		UWORD	dbase_PreviousInstruction
		LABEL	dbase_SIZE

	ENDC
