	IFND	PV_SCREENBASE_I
PV_SCREENBASE_I	SET	1
**
**	$Filename: ScreenBase.i $
**	$Release: 1.13 $
**	$Revision: 37.797 $
**	$Date: 5 Feb 92 $
**
**	Structure definitions for Screen Base (see 'TheWizardCorner')
**
** 	 1991 Jorrit Tyberghein, included with PowerVisor
**	    All Rights Reserved
**

	IFND PV_PVMEMORY_I
	INCLUDE "PV/PVMemory.i"
	ENDC

	IFND DOS_DOS_I
	INCLUDE "dos/dos.i"
	ENDC

	IFND INTUITION_INTUITION_I
	INCLUDE "intuition/intuition.i"
	ENDC


INTMODE_HEX		equ	0
INTMODE_DEC		equ	1
INTMODE_HEXDEC		equ	2

SCROLLMODE_NOMORE	equ	0
SCROLLMODE_MORE		equ	1

SNAPMODE_NOSPACE	equ	0
SNAPMODE_SPACE		equ	1

LONESPC_NO		equ	0
LONESPC_YES		equ	1

SBOTTOMMODE_NO		equ	0
SBOTTOMMODE_YES		equ	1

INTERLACE_NO		equ	0
INTERLACE_YES		equ	1

FANCY_NO		equ	0
FANCY_YES		equ	1

LOGWINFLAGS_PRINTFILE	equ	1
LOGWINFLAGS_PRINTSCREEN	equ	2
LOGWINFLAGS_MORE	equ	4
LOGWINFLAGS_TOTALHOME	equ	32
LOGWINFLAGS_STATUSLINE	equ	64
LOGWINFLAGS_BREAKCHECK	equ	128
LOGWINFLAGS_AUTOOUTPUT	equ	256

BOXTYPE_UPDOWN		equ	0
BOXTYPE_LEFTRIGHT	equ	1
BOXTYPE_ATOMIC		equ	2

COLOR_GRAY		equ	0
COLOR_BLACK		equ	1
COLOR_WHITE		equ	2
COLOR_BLUE		equ	3

Pen_BoxBackground	equ	0
Pen_LWBackground	equ	1
Pen_NormalText		equ	2
Pen_PromptText		equ	3
Pen_StatusTextInActive	equ	4
Pen_StatusTextActive	equ	5
Pen_InActive		equ	6
Pen_Active		equ	7
Pen_TopLeft3D		equ	8
Pen_BottomRight3D	equ	9
Pen_BoxLine		equ	10
Pen_EmptyBox		equ	11
Pen_LeftBox		equ	12
Pen_RightBox		equ	13
Pen_ShowPos3D		equ	14
Pen_SGInActiveText	equ	15
Pen_SGInActiveBack	equ	16
Pen_SGActiveText	equ	17
Pen_SGActiveBack	equ	18
Pen_Hilight		equ	19
Pen_HilightBack		equ	20


** Global structure holding some global window information
**
	STRUCTURE	Global,0
		APTR		gl_NextGlobal
		APTR		gl_PrevGlobal
		STRUCT		gl_PhysWinList,LH_SIZE
		APTR		gl_ActiveLogWin
		ULONG		gl_GlobalSignalSet
		ULONG		gl_pad0
		LABEL		gl_SIZE

** The physical window corresponding with an Intuition window. This
** physical window also manages the logical windows and the boxes.
** Do not depend on the size of this structure !!!
**
	STRUCTURE	PhysicalWindow,LN_SIZE
		STRUCT		pw_NewWindow,nw_SIZE
		APTR		pw_Window
		ULONG		pw_SignalSet
		WORD		pw_LastCode
		WORD		pw_LastQualifier
		BYTE		pw_LeftBorder
		BYTE		pw_TopBorder
		BYTE		pw_RightBorder
		BYTE		pw_BottomBorder
		APTR		pw_MasterBox
		APTR		pw_Global
		STRUCT		pw_LogWinList,LH_SIZE
		LABEL		pw_SIZE

** The logical window.
** Do not depend on the size of this structure !!!
**
	STRUCTURE	LogicalWindow,LN_SIZE
		APTR		lw_Box
		WORD		lw_x
		WORD		lw_y
		WORD		lw_w
		WORD		lw_h
		WORD		lw_FirstVisibleCol
		WORD		lw_FirstVisibleRow
		WORD		lw_CurrentCol
		WORD		lw_CurrentRow
		WORD		lw_VisibleWidth
		WORD		lw_VisibleHeight
		ULONG		lw_Flags
		STRUCT		lw_TextAttr,ta_SIZEOF
		APTR		lw_Font
		WORD		lw_FontWidth
		WORD		lw_FontHeight
		WORD		lw_FontBaseline
		APTR		lw_PhysWin
		WORD		lw_OptCol
		WORD		lw_OptRow
		WORD		lw_NrLinesInBuf
		WORD		lw_NrColsInLine
		APTR		lw_Buffer
		BPTR		lw_LogFile
		WORD		lw_MoreLines
		ULONG		lw_pad0
		APTR		lw_ExtraTitle
		UBYTE		lw_Active
		BYTE		lw_TopBorderStatus
		WORD		lw_RealTopCoordinate
		APTR		lw_userdata
		LABEL		lw_SIZE

** The box used to manage the available space of a physical window.
** Do not depend on the size of this structure !!!
**
	STRUCTURE	Box,0
		APTR		box_Parent
		APTR		box_ChildA
		APTR		box_ChildB
		APTR		box_LogWin
		APTR		box_PhysWin
		WORD		box_ShareA
		BYTE		box_Type
		BYTE		box_Dirty
		BYTE		box_LeftBorder
		BYTE		box_TopBorder
		BYTE		box_RightBorder
		BYTE		box_BottomBorder
		WORD		box_realx
		WORD		box_realy
		WORD		box_realw
		WORD		box_realh
		WORD		box_x1scrollbar
		WORD		box_y1scrollbar
		WORD		box_x2scrollbar
		WORD		box_y2scrollbar
		LABEL		box_SIZE

	STRUCTURE	DefaultLWSize,0
		WORD		dlws_Columns
		WORD		dlws_Rows
		UWORD		dlws_Mask
		UWORD		dlws_Flags
		LABEL		dlws_SIZE


	STRUCTURE	ScreenBase,0
		UBYTE		sbase_IntDisplayMode
		UBYTE		sbase_ScrollMode
		UBYTE		sbase_AddSpaceAfterSnap
		UBYTE		sbase_LoneSpcMode
		UBYTE		sbase_SBottomMode
		UBYTE		sbase_DontClearLine
		UBYTE		sbase_pad0
		UBYTE		sbase_InterlaceMode
		UBYTE		sbase_FancyMode
		UBYTE		sbase_pad1
		ULONG		sbase_CmdLineLen
		APTR		sbase_CmdLine
		UWORD		sbase_CursorPos
		STRUCT		sbase_MainDefSize,dlws_SIZE
		STRUCT		sbase_ExtraDefSize,dlws_SIZE
		STRUCT		sbase_RefreshDefSize,dlws_SIZE
		STRUCT		sbase_DebugDefSize,dlws_SIZE
		STRUCT		sbase_PPrintDefSize,dlws_SIZE
		STRUCT		sbase_RexxDefSize,dlws_SIZE
		STRUCT		sbase_SourceDefSize,dlws_SIZE
		PVBLOCK		sbase_SnapCommand
		LONG		sbase_pad2
		LONG		sbase_pad3
		APTR		sbase_MainPW
		APTR		sbase_MainLW
		APTR		sbase_RefreshLW
		APTR		sbase_DebugLW
		APTR		sbase_ExtraLW
		APTR		sbase_PPrintLW
		APTR		sbase_RexxLW
		APTR		sbase_SourceLW
		APTR		sbase_CurrentLW
		WORD		sbase_PromptPosX
		WORD		sbase_LeftStringPosX
		WORD		sbase_RightStringPosX
		APTR		sbase_OtherScreen
		APTR		sbase_PVScreen
		ULONG		sbase_IMsgClass
		UWORD		sbase_IMsgCode
		APTR		sbase_IMsgIAddress
		WORD		sbase_IMsgMouseX
		WORD		sbase_IMsgMouseY
		UWORD		sbase_IMsgQualifier
		APTR		sbase_TheGlobal
		LONG		sbase_pad4
		LONG		sbase_pad5
		STRUCT		sbase_MainString,8+2
		STRUCT		sbase_ExtraString,8+2
		STRUCT		sbase_DebugString,8+2
		STRUCT		sbase_RefreshString,8+2
		STRUCT		sbase_PPrintString,8+2
		STRUCT		sbase_RexxString,8+2
		STRUCT		sbase_SourceString,8+2
		ULONG		sbase_StartupFlags
		WORD		sbase_WinX
		WORD		sbase_WinY
		WORD		sbase_WinW
		WORD		sbase_WinH
		WORD		sbase_ScreenW
		WORD		sbase_ScreenH
		STRUCT		sbase_FancyPens,24
		STRUCT		sbase_NoFancyPens,24
		APTR		sbase_CurrentPenTable
		STRUCT		sbase_BusyPrompt,6
		STRUCT		sbase_MorePrompt,6
		STRUCT		sbase_WaitPrompt,6
		STRUCT		sbase_LockPrompt,6
		STRUCT		sbase_ScanPrompt,4
		STRUCT		sbase_FeedBackPrompt,2
		APTR		sbase_LockLW
		APTR		sbase_PtrLockPrompt
		UBYTE		sbase_LockState
		UBYTE		sbase_BusyMode
		UBYTE		sbase_GadgetExists
		UBYTE		sbase_pad6
		STRUCT		sbase_DefaultFontName,34
		STRUCT		sbase_DefaultFont,ta_SIZEOF
		UWORD		sbase_LogWinBorderHeight
		UWORD		sbase_pad7
		WORD		sbase_DragToleranceX1
		WORD		sbase_DragToleranceY1
		WORD		sbase_DragToleranceX2
		WORD		sbase_DragToleranceY2
		WORD		sbase_SizeToleranceX
		WORD		sbase_SizeToleranceY
		APTR		sbase_rtRequestStruct
                APTR		sbase_ReqToolsBase
		LABEL		sbase_SIZE

	ENDC
